function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["children", "className", "language", "theme", "data-meta", "data-scope"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { Highlight } from "prism-react-renderer";
import { themes } from "prism-react-renderer";
import PropTypes from "prop-types";
import React, { useMemo } from "react";
import { CodeLive } from "./CodeLive.js";
import { parseMeta } from "./parseMeta.js";
export var Code = function Code(_ref) {
  var children = _ref.children,
    className = _ref.className,
    language = _ref.language,
    theme = _ref.theme,
    dataMeta = _ref["data-meta"],
    dataScope = _ref["data-scope"],
    props = _objectWithoutProperties(_ref, _excluded);
  var meta = useMemo(function () {
    return parseMeta(dataMeta);
  }, [dataMeta]);
  var scope = useMemo(function () {
    return dataScope && JSON.parse(dataScope);
  }, [dataScope]);

  // no language specified? extract one from the className if possible.
  language || (language = className === null || className === void 0 ? void 0 : className.substr('language-'.length));
  var code = children.replace(/(\s+)$/, '');
  if (!language) {
    return /*#__PURE__*/React.createElement("code", null, code);
  }
  if (meta.live) {
    return /*#__PURE__*/React.createElement(CodeLive, _extends({}, meta, {
      className: className,
      code: code,
      language: language,
      scopeMapping: scope
    }));
  }
  return /*#__PURE__*/React.createElement(Highlight, {
    code: code,
    language: language,
    theme: theme
  }, function (_ref2) {
    var className = _ref2.className,
      style = _ref2.style,
      tokens = _ref2.tokens,
      getLineProps = _ref2.getLineProps,
      getTokenProps = _ref2.getTokenProps;
    return /*#__PURE__*/React.createElement("pre", {
      className: className,
      style: _objectSpread(_objectSpread({}, style), {}, {
        padding: "10px"
      })
    }, tokens.map(function (line, i) {
      return /*#__PURE__*/React.createElement("div", getLineProps({
        line: line,
        key: i
      }), line.map(function (token, key) {
        return /*#__PURE__*/React.createElement("span", getTokenProps({
          token: token,
          key: key
        }));
      }));
    }));
  });
};
Code.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  language: PropTypes.string,
  theme: PropTypes.object
};
Code.defaultProps = {
  theme: themes.vsDark
};
//# sourceMappingURL=Code.js.map